【BZOJ3312】[Usaco2013 Nov]No Change 状压DP+二分

【BZOJ3312】[Usaco2013 Nov]No Change

Description

Farmer John is at the market to purchase supplies for his farm. He has in his pocket K coins (1 <= K <= 16), each with value in the range 1..100,000,000. FJ would like to make a sequence of N purchases (1 <= N <= 100,000), where the ith purchase costs c(i) units of money (1 <= c(i) <= 10,000). As he makes this sequence of purchases, he can periodically stop and pay, with a single coin, for all the purchases made since his last payment (of course, the single coin he uses must be large enough to pay for all of these). Unfortunately, the vendors at the market are completely out of change, so whenever FJ uses a coin that is larger than the amount of money he owes, he sadly receives no changes in return! Please compute the maximum amount of money FJ can end up with after making his N purchases in sequence. Output -1 if it is impossible for FJ to make all of his purchases.

K个硬币,要买N个物品。

给定买的顺序,即按顺序必须是一路买过去,当选定买的东西物品序列后,付出钱后,货主是不会找零钱的。现希望买完所需要的东西后,留下的钱越多越好,如果不能完成购买任务,输出-1

Input

Line 1: Two integers, K and N.

* Lines 2..1+K: Each line contains the amount of money of one of FJ's coins.

* Lines 2+K..1+N+K: These N lines contain the costs of FJ's intended purchases. 

Output

* Line 1: The maximum amount of money FJ can end up with, or -1 if FJ cannot complete all of his purchases.

Sample Input

3 6
12
15
10
6
3
3
2
3
7

INPUT DETAILS: FJ has 3 coins of values 12, 15, and 10. He must make purchases in sequence of value 6, 3, 3, 2, 3, and 7.

Sample Output

12
OUTPUT DETAILS: FJ spends his 10-unit coin on the first two purchases, then the 15-unit coin on the remaining purchases. This leaves him with the 12-unit coin.

题解:一开始我心血来潮想用单调队列做,结果发现枚举硬币的顺序会对结果产生影响,所以必须用二维的单调队列,默默放弃~

本题用状压DP是裸题,用f[i]表示状态为i是最多买了几件物品,对于每个状态二分查找每个硬币最多能卖连续的几件物品,就没什么了

 

#include <cstdio>
#include <cstring>
#include <iostream>
using namespace std;
int n,m,ans,sum;
int w[20],s[100010],c[100010],f[1<<17],rem[1<<17];
int main()
{
    scanf("%d%d",&n,&m);
    int i,j,k,t,l,r,mid;
    for(i=1;i<=n;i++)    scanf("%d",&w[i]),rem[0]+=w[i];
    for(i=1;i<=m;i++)    scanf("%d",&c[i]),s[i]=s[i-1]+c[i];
    ans=-1;
    for(i=1;i<(1<<n);i++)
    {
        for(j=1;j<=n;j++)
        {
            if(((1<<j-1)&i)==(1<<j-1))
            {
                t=i^(1<<j-1);
                rem[i]=rem[t]-w[j];
                l=f[t]+1,r=m+1;
                while(l<r)
                {
                    mid=l+r>>1;
                    if(s[mid]-s[f[t]]<=w[j])    l=mid+1;
                    else    r=mid;
                }
                f[i]=max(f[i],l-1);
                if(f[i]==m)    ans=max(ans,rem[i]);
            }
        }
    }
    printf("%d",ans);
    return 0;
}

 

posted @ 2017-02-17 14:17  CQzhangyu  阅读(262)  评论(0编辑  收藏  举报